HDU - 1619 Unidirectional TSP

题目:
Problems that require minimum paths through some domain appear in many different areas of computer science. For example, one of the constraints in VLSI routing problems is minimizing wire length. The Traveling Salesperson Problem (TSP) – finding whether all the cities in a salesperson’s route can be visited exactly once with a specified limit on travel time – is one of the canonical examples of an NP-complete problem; solutions appear to require an inordinate amount of time to generate, but are simple to check.

This problem deals with finding a minimal path through a grid of points while traveling only from left to right.

Given an m*n matrix of integers, you are to write a program that computes a path of minimal weight. A path starts anywhere in column 1 (the first column) and consists of a sequence of steps terminating in column n (the last column). A step consists of traveling from column i to column i+1 in an adjacent (horizontal or diagonal) row. The first and last rows (rows 1 and m) of a matrix are considered adjacent, i.e., the matrix ``wraps’’ so that it represents a horizontal cylinder. Legal steps are illustrated below.

The weight of a path is the sum of the integers in each of the n cells of the matrix that are visited.

For example, two slightly different 5*6 matrices are shown below (the only difference is the numbers in the bottom row).

The minimal path is illustrated for each matrix. Note that the path for the matrix on the right takes advantage of the adjacency property of the first and last rows.

Input
The input consists of a sequence of matrix specifications. Each matrix specification consists of the row and column dimensions in that order on a line followed by integers where m is the row dimension and n is the column dimension. The integers appear in the input in row major order, i.e., the first n integers constitute the first row of the matrix, the second n integers constitute the second row and so on. The integers on a line will be separated from other integers by one or more spaces. Note: integers are not restricted to being positive. There will be one or more matrix specifications in an input file. Input is terminated by end-of-file.

For each specification the number of rows will be between 1 and 10 inclusive; the number of columns will be between 1 and 100 inclusive. No path’s weight will exceed integer values representable using 30 bits
Output
Two lines should be output for each matrix specification in the input file, the first line represents a minimal-weight path, and the second line is the cost of a minimal path. The path consists of a sequence of n integers (separated by one or more spaces) representing the rows that constitute the minimal path. If there is more than one path of minimal weight the path that is lexicographically smallest should be output.

Sample Input
5 6
3 4 1 2 8 6
6 1 8 2 7 4
5 9 3 9 9 5
8 4 1 3 2 6
3 7 2 8 6 4
5 6
3 4 1 2 8 6
6 1 8 2 7 4
5 9 3 9 9 5
8 4 1 3 2 6
3 7 2 1 2 3
2 2
9 10 9 10
Sample Output
1 2 3 4 4 5
16
1 2 1 5 4 5
11
1 1
19

代码如下:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define NIF 0x3f3f3f3f
int a[30][110],dp[30][110],next2[30][110];
int main()
{
	int n,m;
	while(~scanf("%d%d",&n,&m)){
		int ans = NIF,first = 0;
		for(int i = 0;i < n;i++)
			for(int j = 0;j < m;j++)
				cin >> a[i][j];
		memset(dp,NIF,sizeof(dp));	//dp[i][j]代表从i行j列走到最后一列需要的最小值 
		for(int j = m - 1;j >= 0;j--){
			for(int i = 0;i < n;i++){
				if(j == m - 1) dp[i][j] = a[i][j];//最后一列走完需要的值就是a[i][j]
				else{
					int row[3] = {i,i - 1,i + 1};//分别代表从左过来,从左上过来,从左下过来
					if(i == 0) row[1] = n - 1;//第一行的上一行是第n行
					if(i == n - 1) row[2] = 0;//最后一行的下一行是第1行
					sort(row,row + 3);//重新排序,找到字典序最小的
					for(int k = 0;k < 3;k++){
						int v = dp[row[k]][j + 1] + a[i][j];//前一列获得值加上这个值
						if(dp[i][j] > v){
							dp[i][j] = v;//找出最小值 
							next2[i][j] = row[k];//记录走到i行j列的上一个位置是第k行 
						}
					} 
				} 
				if(j == 0 && ans > dp[i][j]){
					ans = dp[i][j];
					first = i;//标记初始行 
				}
			}
		}
		cout << first + 1;
		for(int i = next2[first][0],j = 1;j < m;i = next2[i][j],j++) cout << " " << i + 1;
		cout << endl;
		cout << ans << endl;
	}
	return 0;
}

题意:
给定一个n*m的矩阵,并且这个矩阵是环形的,即第一行的上一行是最后一行,最后一行的下一行是第一行。要求从第一列的任何一行出发,每次沿右或右下或右上到达后面一列,最后到第m列任何一行整个路程的最小值,并且要求是字典序最小的。

思路:
一开始我想让dp[i][j]表示走到i行j列的最小值,但是发现路径很难保存,随后果断放弃,使用从后往前推到,这样保存路径就简化很多了。所以这里dp[i][j]就代表从i行j列走到最后一列需要的最小值 。推导的时候由于是从后往前走,所以相当于是往左,左上,左下走过来。每次走到第一列都要标记初始行first,代表从第first行第1列走到最后一列获得的值最少。

猜你喜欢

转载自blog.csdn.net/qq_41998938/article/details/88603987
TSP
今日推荐